//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  //    
  int board[][8] = {{0},{0},{0},{0},{0},{0},{0},{0}};
  int horizontal[] = {2, 1, -1, -2, -2, -1, 1, 2};
  int vertical[] = {-1, -2, -2, -1, 1, 2, 2, 1};
  int accessibility[][8] = {{2,3,4,4,4,4,3,2},
                            {3,4,6,6,6,6,4,3},
                            {4,6,8,8,8,8,6,4},
                            {4,6,8,8,8,8,6,4},
                            {4,6,8,8,8,8,6,4},
                            {4,6,8,8,8,8,6,4},
                            {3,4,6,6,6,6,4,3},
                            {2,3,4,4,4,4,3,2}};
  //   
  srand(time(NULL));

  bool Go = true; // ,    
  try
   {
     //  
     currentRow = StrToInt(Edit2->Text);
     currentColumn = StrToInt(Edit1->Text);
     //   
     if(currentRow>7 || currentRow<0 || currentColumn>7 ||
                                        currentColumn<0)
      {
       //  
       Application->MessageBoxA("     0  7",
                               "", MB_OK);
       Go = false;
      }
   }
  catch(...)
   {
     Application->MessageBoxA("     0  7",
     "", MB_OK);
     Go = false;
   }
  //  
  if(Go)
   {
    //    
    DecAccessibility(accessibility, horizontal, vertical,
                              currentRow, currentColumn);
    board[currentRow][currentColumn] = 1;
    StringGrid1->Cells[currentColumn][currentRow] = IntToStr(1);

    int MoveNumber; // 
    int count = 1; // 
    bool exit = true; //    

    //    
    do
     {
       MoveNumber = FindMove(board, accessibility, vertical,
                     horizontal, currentRow, currentColumn);
       if (MoveNumber !=-1)
        {
          count++;
          move(board, vertical, horizontal, currentRow,
                     currentColumn, MoveNumber, count);
          DecAccessibility(accessibility, vertical, horizontal,
                                    currentRow, currentColumn);
        }
       else exit = false;
     }
    while(exit);
   }
}
//---------------------------------------------------------------------------
void TForm1::move(int board[][8], int vertical[], int horizontal[],
          int &currentRow, int &currentColumn, int Numb, int cnt)
{
  //  
  currentRow += vertical[Numb];
  currentColumn += horizontal[Numb];
  //,      
  board[currentRow][currentColumn] = 1;
  //    StringGrid
  StringGrid1->Cells[currentColumn][currentRow] = IntToStr(cnt);
}
//---------------------------------------------------------------------------
void TForm1::DecAccessibility(int accessibility[][8],int horizontal[],
                       int vertical[], int crRow, int crColumn)
{
  int Hmove, Vmove; // ,      

  //        1 
  //   accessibility
  for(int i=0; i<8; i++)
   {
     Hmove = crRow + vertical[i];
     Vmove = crColumn + horizontal[i];
     //    
     if((Hmove<8)&&(Hmove>=0)&&(Vmove<8)&&(Vmove>=0))
       accessibility[Hmove][Vmove] -= 1;
   }
}
//---------------------------------------------------------------------------
int TForm1::FindMove(int board[][8], int accessibility[][8],
       int vertical[], int horizontal[], int crRow, int crColumn)
{
  //       .
  //    "-1"    
  //      accessibility
  int PossibleMoves[8] = {-1,-1,-1,-1,-1,-1,-1,-1};

  int tRow, tColumn; // 

  //    
  for(int i=0; i<8; i++)
   {
    tRow = crRow + vertical[i];
    tColumn = crColumn + horizontal[i];
    //      ,    
    //  
    if(tRow<8 && tRow>=0 && tColumn<8 &&tColumn>=0 &&
                             board[tRow][tColumn]==0)
      PossibleMoves[i] = accessibility[tRow][tColumn];
   }

  //  PossibleMoves
  int count = 0;
  int min = 8;
  int Pos = 0;
  //      "-1",  
  //  -   
  for(int j=0; j<8; j++)
   if(PossibleMoves[j]!=-1 && PossibleMoves[j]<=min)
    {
     min = PossibleMoves[j];
     count++;
     Pos = j;
    }

  //  
  if(count==0) return -1;

  //  1  (  )
  if(count==1) return Pos;

  //  ,       
  // .     .  
  //   .
  int Ind = rand()%count;
  for(int k=0; k<8; k++)
    if(PossibleMoves[k]==min && Ind==0)
      {
       Pos = k;
       break;
      }
    else Ind--;
  return Pos;
}
//---------------------------------------------------------------------------





